#include <stdio.h>
#ifdef INTLIZE
#include <libintl.h>
#else
#define gettext(x) (x)
#endif
#include "endian.h"

void
Print_Byte_Order(void)
{
  int EndianNess;

  extern int Get_Endianness(void);

  EndianNess = Get_Endianness();
  switch(EndianNess){
    case E_LITTLE_ENDIAN:
      fprintf(stderr,gettext("This machine is little-endian. (1234 byte order).\n"));
      fprintf(stderr,gettext("That is, the most significant byte is stored in the highest memory address.\n"));
      break;
    case E_BIG_ENDIAN:
      fprintf(stderr,gettext("This machine is big-endian. (4321 byte order).\n"));
      fprintf(stderr,gettext("That is, the most significant byte is stored in the lowest memory address.\n"));
      break;
    case E_PDP_ENDIAN:
      fprintf(stderr,gettext("This machine is PDP-endian and so is probably a PDP-11. (3412 byte order).\n"));
      fprintf(stderr,gettext("In 4-byte integers, the first two bytes are more significant than the second two.\n"));
      fprintf(stderr,gettext("but within each pair, the second byte is the more significant.\n"));
      break;
    default:
      fprintf(stderr,gettext("Unknown byte-ordering\n"));
  }
}

void
Print_Sizes(void)
{
  fprintf(stderr,gettext("Sizes of types on this machine in bytes:\n"));
  fprintf(stderr,"\tunsigned char\t\t%2d\n",sizeof(unsigned char));  
  fprintf(stderr,"\tunsigned short\t\t%2d\n",sizeof(unsigned short));  
  fprintf(stderr,"\tunsigned int\t\t%2d\n",sizeof(unsigned int));  
  fprintf(stderr,"\tunsigned long\t\t%2d\n",sizeof(unsigned long));
#ifdef HAVE_LONG_LONG
  fprintf(stderr,"\tunsigned long long\t%2d\n",sizeof(unsigned long long));
#endif
  fprintf(stderr,"\tsigned char\t\t%2d\n",sizeof(signed char));  
  fprintf(stderr,"\tsigned short\t\t%2d\n",sizeof(signed short));  
  fprintf(stderr,"\tsigned int\t\t%2d\n",sizeof(signed int));  
  fprintf(stderr,"\tsigned long\t\t%2d\n",sizeof(signed long));  
#ifdef HAVE_LONG_LONG
  fprintf(stderr,"\tsigned long long\t%2d\n",sizeof(signed long long));
#endif
  fprintf(stderr,"\tfloat\t\t\t%2d\n",sizeof(float));  
  fprintf(stderr,"\tdouble\t\t\t%2d\n",sizeof(double));
#ifdef HAVE_LONG_DOUBLE
  fprintf(stderr,"\tlong double\t\t%2d\n",sizeof(long double));
#endif
}
